unit Hanprocs;

interface

uses ExtCtrls, SysUtils;

function Scheibe_kleiner_als_top(ScheibenNr, StabNr: integer): boolean;
function Scheibe_ist_top(ScheibenNr: integer): boolean;
procedure Nimm_Scheibe(ScheibenNr: integer);
procedure Setze_Scheibe_nach(ScheibenNr, StabNr: integer);
procedure Verschiebe_Scheibe_nach(ScheibenNr, StabNr: integer);
procedure Verschiebe_Stapel_nach(ScheibenNr, StabNr: integer);
procedure Verschiebe_Stapel_nach_schnell(ScheibenNr, StabNr: integer);

var Scheiben: array[1..3,1..6] of integer;
    AktScheibe: integer;
    AktStab: integer;
    PScheiben: array[1..6] of ^TShape;
    PStab: array[1..3] of ^TShape;

implementation

procedure Warte(t: integer);
var dt: TDateTime;
    ms: double;
begin
  ms:= 1/24/60/60/1000;
  dt:= Now+1.0*t*ms;
  while Now<dt do;

end;

function Scheibe_kleiner_als_top(ScheibenNr, StabNr: integer): boolean;
var i: integer;
begin
  i:= 1;
  while (i<6) and (Scheiben[StabNr,i]=0) do inc(i);
  Scheibe_kleiner_als_top:= (ScheibenNr > Scheiben[StabNr,i]);
end;

function Scheibe_ist_top(ScheibenNr: integer): boolean;
var i,j: integer;
    var ok: boolean;
begin
  ok:= false;
  for i:= 1 to 6 do for j:= 1 to 3 do
    if (Scheiben[j,i]=ScheibenNr) and
       ((i=1) or (Scheiben[j,i-1]=0))
    then ok:= true;
  Scheibe_ist_top:= ok;
end;

procedure Nimm_Scheibe(ScheibenNr: integer);
var i,j: integer;
begin
  for i:= 1 to 6 do for j:= 1 to 3 do
    if Scheiben[j,i]=ScheibenNr then Scheiben[j,i]:= 0;
end;

procedure Setze_Scheibe_nach(ScheibenNr, StabNr: integer);
var i: integer;
begin
  i:= 1;
  while (i<7) and (Scheiben[StabNr,i]=0) do inc(i);
  Scheiben[StabNr,i-1]:= ScheibenNr;
  PScheiben[ScheibenNr]^.Left:= PStab[StabNr]^.Left+PStab[StabNr]^.Width div 2-PScheiben[ScheibenNr]^.Width div 2;
  PScheiben[ScheibenNr]^.Top:= PStab[StabNr]^.Top+PStab[StabNr]^.Height-(8-i)*PScheiben[ScheibenNr]^.Height;
  PScheiben[ScheibenNr]^.Refresh;
end;

procedure Verschiebe_Scheibe_nach(ScheibenNr, StabNr: integer);
begin
  if Scheibe_kleiner_als_Top(ScheibenNr, StabNr)
  then begin
         Nimm_Scheibe(ScheibenNr);
         Setze_Scheibe_nach(ScheibenNr, StabNr);
       end;
end;


procedure Verschiebe_Stapel_nach_schnell(ScheibenNr, StabNr: integer);
var VonStab, Pos: integer;
    i,j: integer;
begin
  if Scheibe_kleiner_als_Top(ScheibenNr, StabNr)
  then begin
         for i:= 1 to 6 do for j:= 1 to 3 do
           if Scheiben[j,i]=ScheibenNr then begin VonStab:= j; Pos:= i; end;
         for i:= Pos downto 1 do
           if Scheiben[VonStab,i]<>0 then Verschiebe_Scheibe_nach(Scheiben[VonStab,i],StabNr);
       end;
end;
 

procedure Verschiebe_Stapel_nach(ScheibenNr,StabNr: integer);
var VonStab, Pos: integer;
    i,j: integer;
    ScheibenNrtop: integer;
begin
  for i:= 1 to 6 do for j:= 1 to 3 do
    if Scheiben[j,i]=ScheibenNr
    then begin
           VonStab:= j;
           Pos:= i;
         end;
  if Scheibe_kleiner_als_Top(ScheibenNr, StabNr)
  then begin
    if Scheibe_ist_Top(ScheibenNr)
    then begin
           Verschiebe_Scheibe_nach(ScheibenNr,StabNr);
           Warte(100);
         end
    else begin
           ScheibenNrTop:= Scheiben[VonStab,Pos-1];
           if Scheibe_kleiner_als_Top(ScheibenNrTop,6-StabNr-VonStab) then
           begin
             Verschiebe_Stapel_nach(ScheibenNrTop,6-StabNr-VonStab);
             Verschiebe_Scheibe_nach(ScheibenNr,StabNr);
             Warte(100);
             Verschiebe_Stapel_nach(ScheibenNrTop,StabNr);
           end;
         end;
  end;
end;

end.
