unit U_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, HanProcs, Menus, StdCtrls, U_Passwd;

const
  Passwort_fuer_Stapel='STAPEL';
  Passwort_fuer_Animation='STAPEL2';

type
  TF_Hanoi = class(TForm)
    S_Stab1: TShape;
    S_Stab2: TShape;
    S_Stab3: TShape;
    S_S1: TShape;
    S_S2: TShape;
    S_S3: TShape;
    S_S4: TShape;
    S_S5: TShape;
    S_S6: TShape;
    Shape1: TShape;
    MainMenu1: TMainMenu;
    MI_Neu: TMenuItem;
    Beenden1: TMenuItem;
    MI_Optionen: TMenuItem;
    MI_Stapel: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MI_Langsam: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure S_S6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure S_S6EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure S_Stab2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MI_NeuClick(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure MI_StapelClick(Sender: TObject);
    procedure MI_LangsamClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  F_Hanoi: TF_Hanoi;
  AnzScheiben: integer;

implementation


{$R *.DFM}

procedure TF_Hanoi.FormCreate(Sender: TObject);
var i: integer;
begin
  AnzScheiben:= 5;
  for i:= 1 to 6 do
  begin
    Scheiben[1,i]:= 0;
    Scheiben[2,i]:= 0;
    Scheiben[3,i]:= 0;
  end;
  AktScheibe:= 0;
  PScheiben[1]:= @(S_S1);
  PScheiben[2]:= @S_S2;
  PScheiben[3]:= @S_S3;
  PScheiben[4]:= @S_S4;
  PScheiben[5]:= @S_S5;
  PScheiben[6]:= @S_S6;
  PStab[1]:= @S_Stab1;
  PStab[2]:= @S_Stab2;
  PStab[3]:= @S_Stab3;
  for i:= 1 to AnzScheiben do Setze_Scheibe_nach(i,1);

end;

procedure TF_Hanoi.S_S6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  AktScheibe:= (Sender as TShape).ComponentIndex-S_S1.ComponentIndex+1;
  if (Scheibe_ist_top(AktScheibe)) or (MI_Stapel.Checked)
  then PScheiben[AktScheibe]^.BeginDrag(true)
  else AktScheibe:= 0;
end;

procedure TF_Hanoi.S_S6EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  AktScheibe:= 0;
end;

procedure TF_Hanoi.S_Stab2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  AktStab:= (Sender as TShape).ComponentIndex-S_Stab1.ComponentIndex+1;
  if (Source is TShape) then
  begin
    if Scheibe_ist_top(AktScheibe)
      then Verschiebe_Scheibe_nach(AktScheibe, AktStab)
      else if MI_Langsam.Checked then Verschiebe_Stapel_nach(AktScheibe, AktStab)
                                 else Verschiebe_Stapel_nach_schnell(AktScheibe, AktStab);
  end;
end;

procedure TF_Hanoi.MI_NeuClick(Sender: TObject);
var i: integer;
    w: string;
begin
  w:= InputBox('Scheiben-Anzahl','Wieviele Scheiben (1-6)?',IntToStr(AnzScheiben));
  if w[1] in ['1'..'6']
    then AnzScheiben:= StrToInt(w[1])
    else AnzScheiben:= 6;
  for i:= 1 to 6 do
  begin
    Scheiben[1,i]:= 0;
    Scheiben[2,i]:= 0;
    Scheiben[3,i]:= 0;
    PScheiben[i]^.visible:= false;
  end;
  for i:= 1 to AnzScheiben do
  begin
    Setze_Scheibe_nach(i,1);
    PScheiben[i]^.visible:= true;
  end;

end;

procedure TF_Hanoi.Beenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TF_Hanoi.MI_StapelClick(Sender: TObject);
begin
  if MI_Stapel.Checked
  then MI_Stapel.Checked:= not MI_Stapel.Checked
  else With F_PasswordDlg do
       begin
         E_Password.Text:= '';
         F_PasswordDlg.ShowModal;
         if E_Password.Text=Passwort_fuer_Stapel
         then MI_Stapel.Checked:= not MI_Stapel.Checked;
       end;
end;

procedure TF_Hanoi.MI_LangsamClick(Sender: TObject);
begin
  if MI_Langsam.Checked
  then MI_Langsam.Checked:= not MI_Langsam.Checked
  else With F_PasswordDlg do
       begin
         E_Password.Text:= '';
         F_PasswordDlg.ShowModal;
         if E_Password.Text=Passwort_fuer_Animation
         then MI_Langsam.Checked:= not MI_Langsam.Checked;
       end;
end;

end.
